/* ========================================
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 * ========================================
*/

#include <project.h>

uint8			AMux_Flag	    = 0;			// Set channel 0 as default
uint8 volatile  AtoDdoneflg     = 0;            // Flag to indicate EOC, end of conversion for A/D
uint16 volatile Deadtime_Ans    = 0;			// Deadtime ADC Answer

uint16 Deadtime_Ans1 = 0;	

float	PWMperiod      = 299.;	  // Starting frequency with 80 kHz, so 24 Mhz / 80 Khz = period value = 150
float	PWMperiod1;
float   PWMcompare1     = 141.;    // Desire that duty cycle = 47%, so PWMcompare = PWM_Period x .47 =~ 70
float   PWMcompare2     = 141.;    // Desire that duty cycle = 47%, so PWMcompare = PWM_Period x .47 =~ 70
float	PWMdeadtime    = 10;		  // Start Deadtime with min 2
float	Turns_Ratio	   = 0.;
float   Freqdesired;

void Sys_Init(void)
{
	LCD_Start();
	LCD_Position(0u,0u);
	LCD_PrintString("Initializing..");	
			
    AMux_Start(); 
	ADC_DelSig_Start( );               // Start the A/D
    ISRatodDone_Start( );              // Enable ISRT for A/D EOC (end of conversion)    	
		
	
	EnabPWMs_Write( 0 );              //  Disable PWMs
	PWM_1_WritePeriod(PWMperiod);	  //	Overwrite PWM's property period value
	PWM_1_WriteCompare1(PWMcompare1);  //	Overwrite PWM's property compare value
	PWM_1_WriteCompare1(PWMcompare2);  //	Overwrite PWM's property compare value
	PWM_1_WriteDeadTime(PWMdeadtime); //	Overwrite PWM's property deadtime value
    PWM_1_Start( );
   	EnabPWMs_Write( 1 );             //  Enable PWMs which will start them
	
    CyGlobalIntEnable;  			 //  Comment this line to disable global interrupts.
	CyDelay(1500); 	
	LCD_ClearDisplay(); 	
}

int main()
{      
	uint16 Deadtime_Ans_Old   = 0;		
	
	Sys_Init();  // Start the components 
			
    ADC_DelSig_StartConvert( );  // Start the ADC conversion	

	AMux_Select(0); 	// Select AMux channel 0		
	AMux_Flag = 0;		// Change AMux Flag to 0
	
    while(1) 
	{		   		
       if ( AtoDdoneflg )     // A/D got a new sample ?
		{       									
			if(AMux_Flag == 0)
			{																										
				Deadtime_Ans1 =  ADC_DelSig_CountsTo_mVolts( Deadtime_Ans );  // Convert A/D counts to mV equivalents
				
				// Display Value on LCD							
				LCD_Position(1u, 0u);				
		    	LCD_PrintString("Deadtime ");	
				LCD_Position (1u,10u);
				LCD_PrintDecUint16(Deadtime_Ans1);
				CyDelay(1000);
				
				/* Start PWM */
				
				// Only update PWMs if A/D has changed > +/- 10 mV
        	    if ( ( Deadtime_Ans1 > Deadtime_Ans_Old  + 10 ) || ( Deadtime_Ans1 < Deadtime_Ans_Old - 10 ) ) 
				{                   			
					Freqdesired = ( -61818.0 * (float) Deadtime_Ans1 / 1000. ) + 280909;
					PWMperiod1 = 1000/(Freqdesired);
                
                	PWMperiod = ( PWMperiod1 + .5 );
                	PWMcompare1 = ( 0.47 * PWMperiod ) + .5;   
					
					
					/*Turns_Ratio = 3.25/(0.5*2*.47);
					//PWMcompare = (float)(3.25/(2*Deadtime_Ans1 * Turns_Ratio)); */
					
					//PWMdeadtime = PWMdeadtime + 1;
					//PWMdeadtime = (240000*(PWMdeadtime + 1)); 
					
					//PWMcompare = (PWMperiod + 1)/((Deadtime_Ans1 + 1) * (47/100));
					//Duty cycle = (Period + 1)/(Compare + 1) * 100%										
					
					PWMcompare1 = (PWMcompare1 + 1) - (PWMdeadtime + 1);
					PWMcompare2 = (PWMperiod + 1) - (PWMcompare2 + 1) - (PWMdeadtime + 1);
					
				if ( Deadtime_Ans1 < 500 )   // Force PWM to stay at 250 Khz for < 500 mV input
				{                                                              
                     PWMperiod = 95.;                                                
                     PWMcompare1 = 45.;							
					 PWMcompare2 = 45.;							
                }                
    		    if ( Deadtime_Ans1 > 3250 )   // Force PWM to stay at 80 Khz for > 3250 mV input
				{                                                             
                     PWMperiod = 299.;                                                
                     PWMcompare1 = 141.;
					 PWMcompare2 = 141.;
                }                	
					Deadtime_Ans_Old = Deadtime_Ans1;
					
					/* Enable PWM */
					EnabPWMs_Write( 0 );                            //  Disable PWMs, reset shift reg for delaying PWM2 start
	
	    			PWM_1_WritePeriod( (uint16) PWMperiod );	    // Update PWM Period value
    				PWM_1_WriteCompare1( (uint16) PWMcompare1 ); 		// Update PWM compare value	
					PWM_1_WriteCompare1( (uint16) PWMcompare2 ); 		// Update PWM compare value	
					PWM_1_WriteDeadTime((uint8)PWMdeadtime );		// Update PWM Deadtime value	
		    			
		    	    EnabPWMs_Write( 1 );                            //  Enable PWMs, enable shift reg for delaying PWM2 start    
				}				
			}	
			AtoDdoneflg = 0;		// Reset A/D EOC flag		
		}
	}
}	